Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for AlphabeticalListOfProducts.  Do not make changes to this class,
     ''' instead, put additional code in the AlphabeticalListOfProducts class
     ''' </summary>
     Public Class AlphabeticalListOfProductsBase
         ' private members
         Private _productID As Integer
         Private _productName As String
         Private _supplierID As System.Nullable(Of Integer)
         Private _categoryID As System.Nullable(Of Integer)
         Private _quantityPerUnit As String
         Private _unitPrice As System.Nullable(Of Decimal)
         Private _unitPriceTotal As Decimal
         Private _unitsInStock As System.Nullable(Of Short)
         Private _unitsOnOrder As System.Nullable(Of Short)
         Private _reorderLevel As System.Nullable(Of Short)
         Private _discontinued As Boolean
         Private _categoryName As String

         ''' <summary>
         ''' Gets or Sets ProductID
         ''' </summary>
         Public Property ProductID() As Integer
             Get
                 Return _productID
             End Get
             Set(ByVal value As Integer)
                 _productID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductName
         ''' </summary>
         Public Property ProductName() As String
             Get
                 Return _productName
             End Get
             Set(ByVal value As String)
                 _productName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets SupplierID
         ''' </summary>
         Public Property SupplierID() As System.Nullable(Of Integer)
             Get
                 Return _supplierID
             End Get
             Set(ByVal value As System.Nullable(Of Integer))
                 _supplierID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CategoryID
         ''' </summary>
         Public Property CategoryID() As System.Nullable(Of Integer)
             Get
                 Return _categoryID
             End Get
             Set(ByVal value As System.Nullable(Of Integer))
                 _categoryID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets QuantityPerUnit
         ''' </summary>
         Public Property QuantityPerUnit() As String
             Get
                 Return _quantityPerUnit
             End Get
             Set(ByVal value As String)
                 _quantityPerUnit = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPrice
         ''' </summary>
         Public Property UnitPrice() As System.Nullable(Of Decimal)
             Get
                 Return _unitPrice
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _unitPrice = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPriceTotal
         ''' </summary>
         Public Property UnitPriceTotal() As Decimal
             Get
                 Return _unitPriceTotal
             End Get
             Set(ByVal value As Decimal)
                 _unitPriceTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitsInStock
         ''' </summary>
         Public Property UnitsInStock() As System.Nullable(Of Short)
             Get
                 Return _unitsInStock
             End Get
             Set(ByVal value As System.Nullable(Of Short))
                 _unitsInStock = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitsOnOrder
         ''' </summary>
         Public Property UnitsOnOrder() As System.Nullable(Of Short)
             Get
                 Return _unitsOnOrder
             End Get
             Set(ByVal value As System.Nullable(Of Short))
                 _unitsOnOrder = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ReorderLevel
         ''' </summary>
         Public Property ReorderLevel() As System.Nullable(Of Short)
             Get
                 Return _reorderLevel
             End Get
             Set(ByVal value As System.Nullable(Of Short))
                 _reorderLevel = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Discontinued
         ''' </summary>
         Public Property Discontinued() As Boolean
             Get
                 Return _discontinued
             End Get
             Set(ByVal value As Boolean)
                 _discontinued = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CategoryName
         ''' </summary>
         Public Property CategoryName() As String
             Get
                 Return _categoryName
             End Get
             Set(ByVal value As String)
                 _categoryName = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the AlphabeticalListOfProducts table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return AlphabeticalListOfProductsDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of AlphabeticalListOfProducts sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As AlphabeticalListOfProductsCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return AlphabeticalListOfProductsDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of AlphabeticalListOfProducts sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As AlphabeticalListOfProductsCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return AlphabeticalListOfProductsDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "ProductID"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares ProductID used for sorting
         ''' </summary>
         Public Shared ByProductID As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return x.ProductID.CompareTo(y.ProductID)
         End Function

         ''' <summary>
         ''' Compares ProductName used for sorting
         ''' </summary>
         Public Shared ByProductName As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Dim value1 As String = If(x.ProductName, String.Empty)
             Dim value2 As String = If(y.ProductName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares SupplierID used for sorting
         ''' </summary>
         Public Shared BySupplierID As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.SupplierID, y.SupplierID)
         End Function

         ''' <summary>
         ''' Compares CategoryID used for sorting
         ''' </summary>
         Public Shared ByCategoryID As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.CategoryID, y.CategoryID)
         End Function

         ''' <summary>
         ''' Compares QuantityPerUnit used for sorting
         ''' </summary>
         Public Shared ByQuantityPerUnit As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Dim value1 As String = If(x.QuantityPerUnit, String.Empty)
             Dim value2 As String = If(y.QuantityPerUnit, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares UnitPrice used for sorting
         ''' </summary>
         Public Shared ByUnitPrice As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.UnitPrice, y.UnitPrice)
         End Function

         ''' <summary>
         ''' Compares UnitsInStock used for sorting
         ''' </summary>
         Public Shared ByUnitsInStock As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.UnitsInStock, y.UnitsInStock)
         End Function

         ''' <summary>
         ''' Compares UnitsOnOrder used for sorting
         ''' </summary>
         Public Shared ByUnitsOnOrder As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.UnitsOnOrder, y.UnitsOnOrder)
         End Function

         ''' <summary>
         ''' Compares ReorderLevel used for sorting
         ''' </summary>
         Public Shared ByReorderLevel As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return Nullable.Compare(x.ReorderLevel, y.ReorderLevel)
         End Function

         ''' <summary>
         ''' Compares Discontinued used for sorting
         ''' </summary>
         Public Shared ByDiscontinued As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Return x.Discontinued.CompareTo(y.Discontinued)
         End Function

         ''' <summary>
         ''' Compares CategoryName used for sorting
         ''' </summary>
         Public Shared ByCategoryName As Comparison(Of AlphabeticalListOfProducts) =
         Function(ByVal x As AlphabeticalListOfProducts, ByVal y As AlphabeticalListOfProducts)
             Dim value1 As String = If(x.CategoryName, String.Empty)
             Dim value2 As String = If(y.CategoryName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

     End Class
End Namespace
