Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for Invoices.  Do not make changes to this class,
     ''' instead, put additional code in the Invoices class
     ''' </summary>
     Public Class InvoicesBase
         ' private members
         Private _shipName As String
         Private _shipAddress As String
         Private _shipCity As String
         Private _shipRegion As String
         Private _shipPostalCode As String
         Private _shipCountry As String
         Private _customerID As String
         Private _customerName As String
         Private _address As String
         Private _city As String
         Private _region1 As String
         Private _postalCode As String
         Private _country As String
         Private _salesperson As String
         Private _orderID As Integer
         Private _orderDate As System.Nullable(Of Date)
         Private _requiredDate As System.Nullable(Of Date)
         Private _shippedDate As System.Nullable(Of Date)
         Private _shipperName As String
         Private _productID As Integer
         Private _productName As String
         Private _unitPrice As Decimal
         Private _unitPriceTotal As Decimal
         Private _quantity As Short
         Private _discount As Single
         Private _extendedPrice As System.Nullable(Of Decimal)
         Private _extendedPriceTotal As Decimal
         Private _freight As System.Nullable(Of Decimal)
         Private _freightTotal As Decimal

         ''' <summary>
         ''' Gets or Sets ShipName
         ''' </summary>
         Public Property ShipName() As String
             Get
                 Return _shipName
             End Get
             Set(ByVal value As String)
                 _shipName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipAddress
         ''' </summary>
         Public Property ShipAddress() As String
             Get
                 Return _shipAddress
             End Get
             Set(ByVal value As String)
                 _shipAddress = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipCity
         ''' </summary>
         Public Property ShipCity() As String
             Get
                 Return _shipCity
             End Get
             Set(ByVal value As String)
                 _shipCity = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipRegion
         ''' </summary>
         Public Property ShipRegion() As String
             Get
                 Return _shipRegion
             End Get
             Set(ByVal value As String)
                 _shipRegion = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipPostalCode
         ''' </summary>
         Public Property ShipPostalCode() As String
             Get
                 Return _shipPostalCode
             End Get
             Set(ByVal value As String)
                 _shipPostalCode = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipCountry
         ''' </summary>
         Public Property ShipCountry() As String
             Get
                 Return _shipCountry
             End Get
             Set(ByVal value As String)
                 _shipCountry = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CustomerID
         ''' </summary>
         Public Property CustomerID() As String
             Get
                 Return _customerID
             End Get
             Set(ByVal value As String)
                 _customerID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CustomerName
         ''' </summary>
         Public Property CustomerName() As String
             Get
                 Return _customerName
             End Get
             Set(ByVal value As String)
                 _customerName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Address
         ''' </summary>
         Public Property Address() As String
             Get
                 Return _address
             End Get
             Set(ByVal value As String)
                 _address = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets City
         ''' </summary>
         Public Property City() As String
             Get
                 Return _city
             End Get
             Set(ByVal value As String)
                 _city = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Region1
         ''' </summary>
         Public Property Region1() As String
             Get
                 Return _region1
             End Get
             Set(ByVal value As String)
                 _region1 = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets PostalCode
         ''' </summary>
         Public Property PostalCode() As String
             Get
                 Return _postalCode
             End Get
             Set(ByVal value As String)
                 _postalCode = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Country
         ''' </summary>
         Public Property Country() As String
             Get
                 Return _country
             End Get
             Set(ByVal value As String)
                 _country = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Salesperson
         ''' </summary>
         Public Property Salesperson() As String
             Get
                 Return _salesperson
             End Get
             Set(ByVal value As String)
                 _salesperson = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets OrderID
         ''' </summary>
         Public Property OrderID() As Integer
             Get
                 Return _orderID
             End Get
             Set(ByVal value As Integer)
                 _orderID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets OrderDate
         ''' </summary>
         Public Property OrderDate() As System.Nullable(Of Date)
             Get
                 Return _orderDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _orderDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets RequiredDate
         ''' </summary>
         Public Property RequiredDate() As System.Nullable(Of Date)
             Get
                 Return _requiredDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _requiredDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShippedDate
         ''' </summary>
         Public Property ShippedDate() As System.Nullable(Of Date)
             Get
                 Return _shippedDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _shippedDate = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShipperName
         ''' </summary>
         Public Property ShipperName() As String
             Get
                 Return _shipperName
             End Get
             Set(ByVal value As String)
                 _shipperName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductID
         ''' </summary>
         Public Property ProductID() As Integer
             Get
                 Return _productID
             End Get
             Set(ByVal value As Integer)
                 _productID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductName
         ''' </summary>
         Public Property ProductName() As String
             Get
                 Return _productName
             End Get
             Set(ByVal value As String)
                 _productName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPrice
         ''' </summary>
         Public Property UnitPrice() As Decimal
             Get
                 Return _unitPrice
             End Get
             Set(ByVal value As Decimal)
                 _unitPrice = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPriceTotal
         ''' </summary>
         Public Property UnitPriceTotal() As Decimal
             Get
                 Return _unitPriceTotal
             End Get
             Set(ByVal value As Decimal)
                 _unitPriceTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Quantity
         ''' </summary>
         Public Property Quantity() As Short
             Get
                 Return _quantity
             End Get
             Set(ByVal value As Short)
                 _quantity = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Discount
         ''' </summary>
         Public Property Discount() As Single
             Get
                 Return _discount
             End Get
             Set(ByVal value As Single)
                 _discount = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ExtendedPrice
         ''' </summary>
         Public Property ExtendedPrice() As System.Nullable(Of Decimal)
             Get
                 Return _extendedPrice
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _extendedPrice = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ExtendedPriceTotal
         ''' </summary>
         Public Property ExtendedPriceTotal() As Decimal
             Get
                 Return _extendedPriceTotal
             End Get
             Set(ByVal value As Decimal)
                 _extendedPriceTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Freight
         ''' </summary>
         Public Property Freight() As System.Nullable(Of Decimal)
             Get
                 Return _freight
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _freight = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets FreightTotal
         ''' </summary>
         Public Property FreightTotal() As Decimal
             Get
                 Return _freightTotal
             End Get
             Set(ByVal value As Decimal)
                 _freightTotal = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the Invoices table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return InvoicesDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of Invoices sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As InvoicesCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return InvoicesDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of Invoices sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As InvoicesCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return InvoicesDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "ShipName"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares ShipName used for sorting
         ''' </summary>
         Public Shared ByShipName As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipName, String.Empty)
             Dim value2 As String = If(y.ShipName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipAddress used for sorting
         ''' </summary>
         Public Shared ByShipAddress As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipAddress, String.Empty)
             Dim value2 As String = If(y.ShipAddress, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipCity used for sorting
         ''' </summary>
         Public Shared ByShipCity As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipCity, String.Empty)
             Dim value2 As String = If(y.ShipCity, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipRegion used for sorting
         ''' </summary>
         Public Shared ByShipRegion As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipRegion, String.Empty)
             Dim value2 As String = If(y.ShipRegion, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipPostalCode used for sorting
         ''' </summary>
         Public Shared ByShipPostalCode As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipPostalCode, String.Empty)
             Dim value2 As String = If(y.ShipPostalCode, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShipCountry used for sorting
         ''' </summary>
         Public Shared ByShipCountry As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipCountry, String.Empty)
             Dim value2 As String = If(y.ShipCountry, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares CustomerID used for sorting
         ''' </summary>
         Public Shared ByCustomerID As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.CustomerID, String.Empty)
             Dim value2 As String = If(y.CustomerID, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares CustomerName used for sorting
         ''' </summary>
         Public Shared ByCustomerName As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.CustomerName, String.Empty)
             Dim value2 As String = If(y.CustomerName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Address used for sorting
         ''' </summary>
         Public Shared ByAddress As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.Address, String.Empty)
             Dim value2 As String = If(y.Address, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares City used for sorting
         ''' </summary>
         Public Shared ByCity As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.City, String.Empty)
             Dim value2 As String = If(y.City, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Region1 used for sorting
         ''' </summary>
         Public Shared ByRegion1 As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.Region1, String.Empty)
             Dim value2 As String = If(y.Region1, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares PostalCode used for sorting
         ''' </summary>
         Public Shared ByPostalCode As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.PostalCode, String.Empty)
             Dim value2 As String = If(y.PostalCode, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Country used for sorting
         ''' </summary>
         Public Shared ByCountry As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.Country, String.Empty)
             Dim value2 As String = If(y.Country, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares Salesperson used for sorting
         ''' </summary>
         Public Shared BySalesperson As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.Salesperson, String.Empty)
             Dim value2 As String = If(y.Salesperson, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares OrderID used for sorting
         ''' </summary>
         Public Shared ByOrderID As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return x.OrderID.CompareTo(y.OrderID)
         End Function

         ''' <summary>
         ''' Compares OrderDate used for sorting
         ''' </summary>
         Public Shared ByOrderDate As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return Nullable.Compare(x.OrderDate, y.OrderDate)
         End Function

         ''' <summary>
         ''' Compares RequiredDate used for sorting
         ''' </summary>
         Public Shared ByRequiredDate As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return Nullable.Compare(x.RequiredDate, y.RequiredDate)
         End Function

         ''' <summary>
         ''' Compares ShippedDate used for sorting
         ''' </summary>
         Public Shared ByShippedDate As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return Nullable.Compare(x.ShippedDate, y.ShippedDate)
         End Function

         ''' <summary>
         ''' Compares ShipperName used for sorting
         ''' </summary>
         Public Shared ByShipperName As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ShipperName, String.Empty)
             Dim value2 As String = If(y.ShipperName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ProductID used for sorting
         ''' </summary>
         Public Shared ByProductID As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return x.ProductID.CompareTo(y.ProductID)
         End Function

         ''' <summary>
         ''' Compares ProductName used for sorting
         ''' </summary>
         Public Shared ByProductName As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Dim value1 As String = If(x.ProductName, String.Empty)
             Dim value2 As String = If(y.ProductName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares UnitPrice used for sorting
         ''' </summary>
         Public Shared ByUnitPrice As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return x.UnitPrice.CompareTo(y.UnitPrice)
         End Function

         ''' <summary>
         ''' Compares Quantity used for sorting
         ''' </summary>
         Public Shared ByQuantity As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return x.Quantity.CompareTo(y.Quantity)
         End Function

         ''' <summary>
         ''' Compares Discount used for sorting
         ''' </summary>
         Public Shared ByDiscount As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return x.Discount.CompareTo(y.Discount)
         End Function

         ''' <summary>
         ''' Compares ExtendedPrice used for sorting
         ''' </summary>
         Public Shared ByExtendedPrice As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return Nullable.Compare(x.ExtendedPrice, y.ExtendedPrice)
         End Function

         ''' <summary>
         ''' Compares Freight used for sorting
         ''' </summary>
         Public Shared ByFreight As Comparison(Of Invoices) =
         Function(ByVal x As Invoices, ByVal y As Invoices)
             Return Nullable.Compare(x.Freight, y.Freight)
         End Function

     End Class
End Namespace
