Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for OrderDetailsExtended.  Do not make changes to this class,
     ''' instead, put additional code in the OrderDetailsExtended class
     ''' </summary>
     Public Class OrderDetailsExtendedBase
         ' private members
         Private _orderID As Integer
         Private _productID As Integer
         Private _productName As String
         Private _unitPrice As Decimal
         Private _unitPriceTotal As Decimal
         Private _quantity As Short
         Private _discount As Single
         Private _extendedPrice As System.Nullable(Of Decimal)
         Private _extendedPriceTotal As Decimal

         ''' <summary>
         ''' Gets or Sets OrderID
         ''' </summary>
         Public Property OrderID() As Integer
             Get
                 Return _orderID
             End Get
             Set(ByVal value As Integer)
                 _orderID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductID
         ''' </summary>
         Public Property ProductID() As Integer
             Get
                 Return _productID
             End Get
             Set(ByVal value As Integer)
                 _productID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductName
         ''' </summary>
         Public Property ProductName() As String
             Get
                 Return _productName
             End Get
             Set(ByVal value As String)
                 _productName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPrice
         ''' </summary>
         Public Property UnitPrice() As Decimal
             Get
                 Return _unitPrice
             End Get
             Set(ByVal value As Decimal)
                 _unitPrice = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitPriceTotal
         ''' </summary>
         Public Property UnitPriceTotal() As Decimal
             Get
                 Return _unitPriceTotal
             End Get
             Set(ByVal value As Decimal)
                 _unitPriceTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Quantity
         ''' </summary>
         Public Property Quantity() As Short
             Get
                 Return _quantity
             End Get
             Set(ByVal value As Short)
                 _quantity = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Discount
         ''' </summary>
         Public Property Discount() As Single
             Get
                 Return _discount
             End Get
             Set(ByVal value As Single)
                 _discount = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ExtendedPrice
         ''' </summary>
         Public Property ExtendedPrice() As System.Nullable(Of Decimal)
             Get
                 Return _extendedPrice
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _extendedPrice = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ExtendedPriceTotal
         ''' </summary>
         Public Property ExtendedPriceTotal() As Decimal
             Get
                 Return _extendedPriceTotal
             End Get
             Set(ByVal value As Decimal)
                 _extendedPriceTotal = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the OrderDetailsExtended table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return OrderDetailsExtendedDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of OrderDetailsExtended sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As OrderDetailsExtendedCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return OrderDetailsExtendedDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of OrderDetailsExtended sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As OrderDetailsExtendedCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return OrderDetailsExtendedDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "OrderID"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares OrderID used for sorting
         ''' </summary>
         Public Shared ByOrderID As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return x.OrderID.CompareTo(y.OrderID)
         End Function

         ''' <summary>
         ''' Compares ProductID used for sorting
         ''' </summary>
         Public Shared ByProductID As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return x.ProductID.CompareTo(y.ProductID)
         End Function

         ''' <summary>
         ''' Compares ProductName used for sorting
         ''' </summary>
         Public Shared ByProductName As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Dim value1 As String = If(x.ProductName, String.Empty)
             Dim value2 As String = If(y.ProductName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares UnitPrice used for sorting
         ''' </summary>
         Public Shared ByUnitPrice As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return x.UnitPrice.CompareTo(y.UnitPrice)
         End Function

         ''' <summary>
         ''' Compares Quantity used for sorting
         ''' </summary>
         Public Shared ByQuantity As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return x.Quantity.CompareTo(y.Quantity)
         End Function

         ''' <summary>
         ''' Compares Discount used for sorting
         ''' </summary>
         Public Shared ByDiscount As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return x.Discount.CompareTo(y.Discount)
         End Function

         ''' <summary>
         ''' Compares ExtendedPrice used for sorting
         ''' </summary>
         Public Shared ByExtendedPrice As Comparison(Of OrderDetailsExtended) =
         Function(ByVal x As OrderDetailsExtended, ByVal y As OrderDetailsExtended)
             Return Nullable.Compare(x.ExtendedPrice, y.ExtendedPrice)
         End Function

     End Class
End Namespace
