Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for ProductsByCategory.  Do not make changes to this class,
     ''' instead, put additional code in the ProductsByCategory class
     ''' </summary>
     Public Class ProductsByCategoryBase
         ' private members
         Private _categoryName As String
         Private _productName As String
         Private _quantityPerUnit As String
         Private _unitsInStock As System.Nullable(Of Short)
         Private _discontinued As Boolean

         ''' <summary>
         ''' Gets or Sets CategoryName
         ''' </summary>
         Public Property CategoryName() As String
             Get
                 Return _categoryName
             End Get
             Set(ByVal value As String)
                 _categoryName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductName
         ''' </summary>
         Public Property ProductName() As String
             Get
                 Return _productName
             End Get
             Set(ByVal value As String)
                 _productName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets QuantityPerUnit
         ''' </summary>
         Public Property QuantityPerUnit() As String
             Get
                 Return _quantityPerUnit
             End Get
             Set(ByVal value As String)
                 _quantityPerUnit = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets UnitsInStock
         ''' </summary>
         Public Property UnitsInStock() As System.Nullable(Of Short)
             Get
                 Return _unitsInStock
             End Get
             Set(ByVal value As System.Nullable(Of Short))
                 _unitsInStock = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets Discontinued
         ''' </summary>
         Public Property Discontinued() As Boolean
             Get
                 Return _discontinued
             End Get
             Set(ByVal value As Boolean)
                 _discontinued = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the ProductsByCategory table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return ProductsByCategoryDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of ProductsByCategory sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As ProductsByCategoryCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return ProductsByCategoryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of ProductsByCategory sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As ProductsByCategoryCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return ProductsByCategoryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "CategoryName"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares CategoryName used for sorting
         ''' </summary>
         Public Shared ByCategoryName As Comparison(Of ProductsByCategory) =
         Function(ByVal x As ProductsByCategory, ByVal y As ProductsByCategory)
             Dim value1 As String = If(x.CategoryName, String.Empty)
             Dim value2 As String = If(y.CategoryName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ProductName used for sorting
         ''' </summary>
         Public Shared ByProductName As Comparison(Of ProductsByCategory) =
         Function(ByVal x As ProductsByCategory, ByVal y As ProductsByCategory)
             Dim value1 As String = If(x.ProductName, String.Empty)
             Dim value2 As String = If(y.ProductName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares QuantityPerUnit used for sorting
         ''' </summary>
         Public Shared ByQuantityPerUnit As Comparison(Of ProductsByCategory) =
         Function(ByVal x As ProductsByCategory, ByVal y As ProductsByCategory)
             Dim value1 As String = If(x.QuantityPerUnit, String.Empty)
             Dim value2 As String = If(y.QuantityPerUnit, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares UnitsInStock used for sorting
         ''' </summary>
         Public Shared ByUnitsInStock As Comparison(Of ProductsByCategory) =
         Function(ByVal x As ProductsByCategory, ByVal y As ProductsByCategory)
             Return Nullable.Compare(x.UnitsInStock, y.UnitsInStock)
         End Function

         ''' <summary>
         ''' Compares Discontinued used for sorting
         ''' </summary>
         Public Shared ByDiscontinued As Comparison(Of ProductsByCategory) =
         Function(ByVal x As ProductsByCategory, ByVal y As ProductsByCategory)
             Return x.Discontinued.CompareTo(y.Discontinued)
         End Function

     End Class
End Namespace
