Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for SalesByCategory.  Do not make changes to this class,
     ''' instead, put additional code in the SalesByCategory class
     ''' </summary>
     Public Class SalesByCategoryBase
         ' private members
         Private _categoryID As Integer
         Private _categoryName As String
         Private _productName As String
         Private _productSales As System.Nullable(Of Decimal)
         Private _productSalesTotal As Decimal

         ''' <summary>
         ''' Gets or Sets CategoryID
         ''' </summary>
         Public Property CategoryID() As Integer
             Get
                 Return _categoryID
             End Get
             Set(ByVal value As Integer)
                 _categoryID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CategoryName
         ''' </summary>
         Public Property CategoryName() As String
             Get
                 Return _categoryName
             End Get
             Set(ByVal value As String)
                 _categoryName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductName
         ''' </summary>
         Public Property ProductName() As String
             Get
                 Return _productName
             End Get
             Set(ByVal value As String)
                 _productName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductSales
         ''' </summary>
         Public Property ProductSales() As System.Nullable(Of Decimal)
             Get
                 Return _productSales
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _productSales = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ProductSalesTotal
         ''' </summary>
         Public Property ProductSalesTotal() As Decimal
             Get
                 Return _productSalesTotal
             End Get
             Set(ByVal value As Decimal)
                 _productSalesTotal = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the SalesByCategory table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return SalesByCategoryDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SalesByCategory sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As SalesByCategoryCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return SalesByCategoryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SalesByCategory sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As SalesByCategoryCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return SalesByCategoryDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "CategoryID"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares CategoryID used for sorting
         ''' </summary>
         Public Shared ByCategoryID As Comparison(Of SalesByCategory) =
         Function(ByVal x As SalesByCategory, ByVal y As SalesByCategory)
             Return x.CategoryID.CompareTo(y.CategoryID)
         End Function

         ''' <summary>
         ''' Compares CategoryName used for sorting
         ''' </summary>
         Public Shared ByCategoryName As Comparison(Of SalesByCategory) =
         Function(ByVal x As SalesByCategory, ByVal y As SalesByCategory)
             Dim value1 As String = If(x.CategoryName, String.Empty)
             Dim value2 As String = If(y.CategoryName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ProductName used for sorting
         ''' </summary>
         Public Shared ByProductName As Comparison(Of SalesByCategory) =
         Function(ByVal x As SalesByCategory, ByVal y As SalesByCategory)
             Dim value1 As String = If(x.ProductName, String.Empty)
             Dim value2 As String = If(y.ProductName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ProductSales used for sorting
         ''' </summary>
         Public Shared ByProductSales As Comparison(Of SalesByCategory) =
         Function(ByVal x As SalesByCategory, ByVal y As SalesByCategory)
             Return Nullable.Compare(x.ProductSales, y.ProductSales)
         End Function

     End Class
End Namespace
