Imports System
Imports System.Data
Imports NorthwindWinFormViewsDynamic_VB.DataLayer
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject
Imports NorthwindWinFormViewsDynamic_VB.Models
Imports System.Runtime.InteropServices

Namespace BusinessObject.Base

     ''' <summary>
     ''' Base class for SalesTotalsByAmount.  Do not make changes to this class,
     ''' instead, put additional code in the SalesTotalsByAmount class
     ''' </summary>
     Public Class SalesTotalsByAmountBase
         ' private members
         Private _saleAmount As System.Nullable(Of Decimal)
         Private _saleAmountTotal As Decimal
         Private _orderID As Integer
         Private _companyName As String
         Private _shippedDate As System.Nullable(Of Date)

         ''' <summary>
         ''' Gets or Sets SaleAmount
         ''' </summary>
         Public Property SaleAmount() As System.Nullable(Of Decimal)
             Get
                 Return _saleAmount
             End Get
             Set(ByVal value As System.Nullable(Of Decimal))
                 _saleAmount = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets SaleAmountTotal
         ''' </summary>
         Public Property SaleAmountTotal() As Decimal
             Get
                 Return _saleAmountTotal
             End Get
             Set(ByVal value As Decimal)
                 _saleAmountTotal = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets OrderID
         ''' </summary>
         Public Property OrderID() As Integer
             Get
                 Return _orderID
             End Get
             Set(ByVal value As Integer)
                 _orderID = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets CompanyName
         ''' </summary>
         Public Property CompanyName() As String
             Get
                 Return _companyName
             End Get
             Set(ByVal value As String)
                 _companyName = value
             End Set
         End Property

         ''' <summary>
         ''' Gets or Sets ShippedDate
         ''' </summary>
         Public Property ShippedDate() As System.Nullable(Of Date)
             Get
                 Return _shippedDate
             End Get
             Set(ByVal value As System.Nullable(Of Date))
                 _shippedDate = value
             End Set
         End Property


         ''' <summary>
         ''' Constructor
         ''' </summary>
         Public Sub New()
         End Sub

         ''' <summary>
         ''' Gets the total number of records in the SalesTotalsByAmount table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Return SalesTotalsByAmountDataLayer.GetRecordCount()
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SalesTotalsByAmount sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, <Out()> ByRef totalRowCount As Integer, sortByExpression As String) As SalesTotalsByAmountCollection
             totalRowCount = GetRecordCount()
             sortByExpression = GetSortExpression(sortByExpression)

             Return SalesTotalsByAmountDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Selects records as a collection (List) of SalesTotalsByAmount sorted by the sortByExpression and returns the rows (# of records) starting from the startRowIndex.  Use for non model-binded gridview control.  Does not return total row count.
         ''' </summary>
         Public Shared Function SelectSkipAndTake(rows As Integer, startRowIndex As Integer, sortByExpression As String) As SalesTotalsByAmountCollection
             sortByExpression = GetSortExpression(sortByExpression)
             Return SalesTotalsByAmountDataLayer.SelectSkipAndTake(sortByExpression, startRowIndex, rows)
         End Function

         Private Shared Function GetSortExpression(sortByExpression As String) As String
             If [String].IsNullOrEmpty(sortByExpression) Or sortByExpression = " asc" Then
                 sortByExpression = "SaleAmount"
             Else If sortByExpression.Contains(" asc") Then
                 sortByExpression = sortByExpression.Replace(" asc", "")
             End If

             Return sortByExpression
         End Function

         ''' <summary>
         ''' Compares SaleAmount used for sorting
         ''' </summary>
         Public Shared BySaleAmount As Comparison(Of SalesTotalsByAmount) =
         Function(ByVal x As SalesTotalsByAmount, ByVal y As SalesTotalsByAmount)
             Return Nullable.Compare(x.SaleAmount, y.SaleAmount)
         End Function

         ''' <summary>
         ''' Compares OrderID used for sorting
         ''' </summary>
         Public Shared ByOrderID As Comparison(Of SalesTotalsByAmount) =
         Function(ByVal x As SalesTotalsByAmount, ByVal y As SalesTotalsByAmount)
             Return x.OrderID.CompareTo(y.OrderID)
         End Function

         ''' <summary>
         ''' Compares CompanyName used for sorting
         ''' </summary>
         Public Shared ByCompanyName As Comparison(Of SalesTotalsByAmount) =
         Function(ByVal x As SalesTotalsByAmount, ByVal y As SalesTotalsByAmount)
             Dim value1 As String = If(x.CompanyName, String.Empty)
             Dim value2 As String = If(y.CompanyName, String.Empty)
             Return value1.CompareTo(value2)
         End Function

         ''' <summary>
         ''' Compares ShippedDate used for sorting
         ''' </summary>
         Public Shared ByShippedDate As Comparison(Of SalesTotalsByAmount) =
         Function(ByVal x As SalesTotalsByAmount, ByVal y As SalesTotalsByAmount)
             Return Nullable.Compare(x.ShippedDate, y.ShippedDate)
         End Function

     End Class
End Namespace
