Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for AlphabeticalListOfProductsDataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the AlphabeticalListOfProductsDataLayer class
     ''' </summary>
     Public Class AlphabeticalListOfProductsDataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As AlphabeticalListOfProductsCollection
              Dim objAlphabeticalListOfProductsCol As AlphabeticalListOfProductsCollection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objAlphabeticalListOfProductsCol = New AlphabeticalListOfProductsCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objAlphabeticalListOfProducts As AlphabeticalListOfProducts = CreateAlphabeticalListOfProductsFromDataRowShared(dr)
                                      objAlphabeticalListOfProductsCol.Add(objAlphabeticalListOfProducts)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objAlphabeticalListOfProductsCol
         End Function

         ''' <summary>
         ''' Gets the total number of records in the AlphabeticalListOfProducts table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = AlphabeticalListOfProductsSql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects AlphabeticalListOfProducts records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As AlphabeticalListOfProductsCollection
             Dim dynamicSqlScript As String = AlphabeticalListOfProductsSql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Creates a AlphabeticalListOfProducts object from the passed data row
         ''' </summary>
         Private Shared Function CreateAlphabeticalListOfProductsFromDataRowShared(dr As DataRow) As AlphabeticalListOfProducts
             Dim objAlphabeticalListOfProducts As AlphabeticalListOfProducts = New AlphabeticalListOfProducts()


             If Not DbNull.Value.Equals(dr("ProductID")) Then
                 objAlphabeticalListOfProducts.ProductID = DirectCast(dr("ProductID"), Integer)
             Else
                 objAlphabeticalListOfProducts.ProductID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ProductName")) Then
                 objAlphabeticalListOfProducts.ProductName = dr("ProductName").ToString()
             Else
                 objAlphabeticalListOfProducts.ProductName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("SupplierID")) Then
                 objAlphabeticalListOfProducts.SupplierID = DirectCast(dr("SupplierID"), Integer)
             Else
                 objAlphabeticalListOfProducts.SupplierID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("CategoryID")) Then
                 objAlphabeticalListOfProducts.CategoryID = DirectCast(dr("CategoryID"), Integer)
             Else
                 objAlphabeticalListOfProducts.CategoryID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("QuantityPerUnit")) Then
                 objAlphabeticalListOfProducts.QuantityPerUnit = dr("QuantityPerUnit").ToString()
             Else
                 objAlphabeticalListOfProducts.QuantityPerUnit = Nothing
             End If

             If Not DbNull.Value.Equals(dr("UnitPrice")) Then
                 objAlphabeticalListOfProducts.UnitPrice = DirectCast(dr("UnitPrice"), Decimal)
             Else
                 objAlphabeticalListOfProducts.UnitPrice = Nothing
             End If

             If Not DbNull.Value.Equals(dr("UnitsInStock")) Then
                 objAlphabeticalListOfProducts.UnitsInStock = DirectCast(dr("UnitsInStock"), Short)
             Else
                 objAlphabeticalListOfProducts.UnitsInStock = Nothing
             End If

             If Not DbNull.Value.Equals(dr("UnitsOnOrder")) Then
                 objAlphabeticalListOfProducts.UnitsOnOrder = DirectCast(dr("UnitsOnOrder"), Short)
             Else
                 objAlphabeticalListOfProducts.UnitsOnOrder = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ReorderLevel")) Then
                 objAlphabeticalListOfProducts.ReorderLevel = DirectCast(dr("ReorderLevel"), Short)
             Else
                 objAlphabeticalListOfProducts.ReorderLevel = Nothing
             End If

             If Not DbNull.Value.Equals(dr("Discontinued")) Then
                 objAlphabeticalListOfProducts.Discontinued = DirectCast(dr("Discontinued"), Boolean)
             Else
                 objAlphabeticalListOfProducts.Discontinued = Nothing
             End If

             If Not DbNull.Value.Equals(dr("CategoryName")) Then
                 objAlphabeticalListOfProducts.CategoryName = dr("CategoryName").ToString()
             Else
                 objAlphabeticalListOfProducts.CategoryName = Nothing
             End If

             Return objAlphabeticalListOfProducts
         End Function
     End Class
End Namespace
