Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for CategorySalesFor1997DataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the CategorySalesFor1997DataLayer class
     ''' </summary>
     Public Class CategorySalesFor1997DataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As CategorySalesFor1997Collection
              Dim objCategorySalesFor1997Col As CategorySalesFor1997Collection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objCategorySalesFor1997Col = New CategorySalesFor1997Collection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objCategorySalesFor1997 As CategorySalesFor1997 = CreateCategorySalesFor1997FromDataRowShared(dr)
                                      objCategorySalesFor1997Col.Add(objCategorySalesFor1997)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objCategorySalesFor1997Col
         End Function

         ''' <summary>
         ''' Gets the total number of records in the CategorySalesFor1997 table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = CategorySalesFor1997Sql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects CategorySalesFor1997 records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As CategorySalesFor1997Collection
             Dim dynamicSqlScript As String = CategorySalesFor1997Sql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Creates a CategorySalesFor1997 object from the passed data row
         ''' </summary>
         Private Shared Function CreateCategorySalesFor1997FromDataRowShared(dr As DataRow) As CategorySalesFor1997
             Dim objCategorySalesFor1997 As CategorySalesFor1997 = New CategorySalesFor1997()


             If Not DbNull.Value.Equals(dr("CategoryName")) Then
                 objCategorySalesFor1997.CategoryName = dr("CategoryName").ToString()
             Else
                 objCategorySalesFor1997.CategoryName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("CategorySales")) Then
                 objCategorySalesFor1997.CategorySales = DirectCast(dr("CategorySales"), Decimal)
             Else
                 objCategorySalesFor1997.CategorySales = Nothing
             End If

             Return objCategorySalesFor1997
         End Function
     End Class
End Namespace
