Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for OrderDetailsExtendedDataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the OrderDetailsExtendedDataLayer class
     ''' </summary>
     Public Class OrderDetailsExtendedDataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As OrderDetailsExtendedCollection
              Dim objOrderDetailsExtendedCol As OrderDetailsExtendedCollection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objOrderDetailsExtendedCol = New OrderDetailsExtendedCollection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objOrderDetailsExtended As OrderDetailsExtended = CreateOrderDetailsExtendedFromDataRowShared(dr)
                                      objOrderDetailsExtendedCol.Add(objOrderDetailsExtended)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objOrderDetailsExtendedCol
         End Function

         ''' <summary>
         ''' Gets the total number of records in the OrderDetailsExtended table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = OrderDetailsExtendedSql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects OrderDetailsExtended records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As OrderDetailsExtendedCollection
             Dim dynamicSqlScript As String = OrderDetailsExtendedSql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Creates a OrderDetailsExtended object from the passed data row
         ''' </summary>
         Private Shared Function CreateOrderDetailsExtendedFromDataRowShared(dr As DataRow) As OrderDetailsExtended
             Dim objOrderDetailsExtended As OrderDetailsExtended = New OrderDetailsExtended()


             If Not DbNull.Value.Equals(dr("OrderID")) Then
                 objOrderDetailsExtended.OrderID = DirectCast(dr("OrderID"), Integer)
             Else
                 objOrderDetailsExtended.OrderID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ProductID")) Then
                 objOrderDetailsExtended.ProductID = DirectCast(dr("ProductID"), Integer)
             Else
                 objOrderDetailsExtended.ProductID = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ProductName")) Then
                 objOrderDetailsExtended.ProductName = dr("ProductName").ToString()
             Else
                 objOrderDetailsExtended.ProductName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("UnitPrice")) Then
                 objOrderDetailsExtended.UnitPrice = DirectCast(dr("UnitPrice"), Decimal)
             Else
                 objOrderDetailsExtended.UnitPrice = Nothing
             End If

             If Not DbNull.Value.Equals(dr("Quantity")) Then
                 objOrderDetailsExtended.Quantity = DirectCast(dr("Quantity"), Short)
             Else
                 objOrderDetailsExtended.Quantity = Nothing
             End If

             If Not DbNull.Value.Equals(dr("Discount")) Then
                 objOrderDetailsExtended.Discount = DirectCast(dr("Discount"), Single)
             Else
                 objOrderDetailsExtended.Discount = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ExtendedPrice")) Then
                 objOrderDetailsExtended.ExtendedPrice = DirectCast(dr("ExtendedPrice"), Decimal)
             Else
                 objOrderDetailsExtended.ExtendedPrice = Nothing
             End If

             Return objOrderDetailsExtended
         End Function
     End Class
End Namespace
