Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports NorthwindWinFormViewsDynamic_VB.BusinessObject

Namespace DataLayer.Base
     ''' <summary>
     ''' Base class for ProductSalesFor1997DataLayer.  Do not make changes to this class,
     ''' instead, put additional code in the ProductSalesFor1997DataLayer class
     ''' </summary>
     Public Class ProductSalesFor1997DataLayerBase

         ' constructor
         Public Sub New()
         End Sub

         Public Shared Function SelectShared(dynamicSqlScript As String, param As String, paramValue As Object, Optional ByVal sortByExpression As String = Nothing, Optional ByVal startRowIndex As Integer? = Nothing, Optional ByVal rows As Integer? = Nothing) As ProductSalesFor1997Collection
              Dim objProductSalesFor1997Col As ProductSalesFor1997Collection = Nothing

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      ' select, skip, take, sort parameters
                      If Not [String].IsNullOrEmpty(sortByExpression) AndAlso startRowIndex IsNot Nothing AndAlso rows IsNot Nothing Then
                          command.Parameters.AddWithValue("@start", startRowIndex.Value)
                          command.Parameters.AddWithValue("@numberOfRows", rows.Value)
                          command.Parameters.AddWithValue("@sortByExpression", sortByExpression)
                      End If

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  objProductSalesFor1997Col = New ProductSalesFor1997Collection()

                                  For Each dr As DataRow In dt.Rows
                                      Dim objProductSalesFor1997 As ProductSalesFor1997 = CreateProductSalesFor1997FromDataRowShared(dr)
                                      objProductSalesFor1997Col.Add(objProductSalesFor1997)
                                  Next
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return objProductSalesFor1997Col
         End Function

         ''' <summary>
         ''' Gets the total number of records in the ProductSalesFor1997 table
         ''' </summary>
         Public Shared Function GetRecordCount() As Integer
             Dim sql As String = ProductSalesFor1997Sql.GetRecordCount()
             Return GetRecordCountShared(Nothing, Nothing, Nothing, False, sql)
         End Function

         Public Shared Function GetRecordCountShared(Optional ByVal storedProcName As String = Nothing, Optional ByVal param As String = Nothing, Optional ByVal paramValue As Object = Nothing, Optional ByVal isUseStoredProc As Boolean = True, Optional ByVal dynamicSqlScript As String = Nothing) As Integer
              Dim recordCount As Integer = 0

              Using connection As New SqlConnection(ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString)
                  connection.Open()

                  Using command As New SqlCommand(dynamicSqlScript, connection)
                      command.CommandType = CommandType.Text

                      Using da As New SqlDataAdapter(command)
                          Dim dt As New DataTable()
                          da.Fill(dt)

                          If dt IsNot Nothing Then
                              If dt.Rows.Count > 0 Then
                                  recordCount = DirectCast(dt.Rows(0)("RecordCount"), Integer)
                              End If
                          End If
                      End Using
                  End Using
              End Using

              Return recordCount
         End Function

         ''' <summary>
         ''' Selects ProductSalesFor1997 records sorted by the sortByExpression and returns records from the startRowIndex with rows (# of records)
         ''' </summary>
         Public Shared Function SelectSkipAndTake(sortByExpression As String, startRowIndex As Integer, rows As Integer) As ProductSalesFor1997Collection
             Dim dynamicSqlScript As String = ProductSalesFor1997Sql.SelectSkipAndTake()
             Return SelectShared(dynamicSqlScript, Nothing, Nothing, sortByExpression, startRowIndex, rows)
         End Function

         ''' <summary>
         ''' Creates a ProductSalesFor1997 object from the passed data row
         ''' </summary>
         Private Shared Function CreateProductSalesFor1997FromDataRowShared(dr As DataRow) As ProductSalesFor1997
             Dim objProductSalesFor1997 As ProductSalesFor1997 = New ProductSalesFor1997()


             If Not DbNull.Value.Equals(dr("CategoryName")) Then
                 objProductSalesFor1997.CategoryName = dr("CategoryName").ToString()
             Else
                 objProductSalesFor1997.CategoryName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ProductName")) Then
                 objProductSalesFor1997.ProductName = dr("ProductName").ToString()
             Else
                 objProductSalesFor1997.ProductName = Nothing
             End If

             If Not DbNull.Value.Equals(dr("ProductSales")) Then
                 objProductSalesFor1997.ProductSales = DirectCast(dr("ProductSales"), Decimal)
             Else
                 objProductSalesFor1997.ProductSales = Nothing
             End If

             Return objProductSalesFor1997
         End Function
     End Class
End Namespace
