Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class InvoicesSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Invoices]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[ShipName], ")
            sb.Append("[ShipAddress], ")
            sb.Append("[ShipCity], ")
            sb.Append("[ShipRegion], ")
            sb.Append("[ShipPostalCode], ")
            sb.Append("[ShipCountry], ")
            sb.Append("[CustomerID], ")
            sb.Append("[CustomerName], ")
            sb.Append("[Address], ")
            sb.Append("[City], ")
            sb.Append("[Region] AS [Region1], ")
            sb.Append("[PostalCode], ")
            sb.Append("[Country], ")
            sb.Append("[Salesperson], ")
            sb.Append("[OrderID], ")
            sb.Append("[OrderDate], ")
            sb.Append("[RequiredDate], ")
            sb.Append("[ShippedDate], ")
            sb.Append("[ShipperName], ")
            sb.Append("[ProductID], ")
            sb.Append("[ProductName], ")
            sb.Append("[UnitPrice], ")
            sb.Append("[Quantity], ")
            sb.Append("[Discount], ")
            sb.Append("[ExtendedPrice], ")
            sb.Append("[Freight] ")
            sb.Append("FROM [dbo].[Invoices] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipName' THEN [ShipName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipName desc' THEN [ShipName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipAddress' THEN [ShipAddress] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipAddress desc' THEN [ShipAddress] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipCity' THEN [ShipCity] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipCity desc' THEN [ShipCity] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipRegion' THEN [ShipRegion] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipRegion desc' THEN [ShipRegion] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipPostalCode' THEN [ShipPostalCode] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipPostalCode desc' THEN [ShipPostalCode] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipCountry' THEN [ShipCountry] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipCountry desc' THEN [ShipCountry] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID' THEN [CustomerID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerID desc' THEN [CustomerID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CustomerName' THEN [CustomerName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CustomerName desc' THEN [CustomerName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Address' THEN [Address] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Address desc' THEN [Address] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'City' THEN [City] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'City desc' THEN [City] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Region1' THEN [Region] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Region1 desc' THEN [Region] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode' THEN [PostalCode] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'PostalCode desc' THEN [PostalCode] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Country' THEN [Country] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Country desc' THEN [Country] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Salesperson' THEN [Salesperson] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Salesperson desc' THEN [Salesperson] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'OrderDate' THEN [OrderDate] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'OrderDate desc' THEN [OrderDate] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'RequiredDate' THEN [RequiredDate] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'RequiredDate desc' THEN [RequiredDate] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate' THEN [ShippedDate] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShippedDate desc' THEN [ShippedDate] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ShipperName' THEN [ShipperName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ShipperName desc' THEN [ShipperName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductID' THEN [ProductID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductID desc' THEN [ProductID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice' THEN [UnitPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice desc' THEN [UnitPrice] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Quantity' THEN [Quantity] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Quantity desc' THEN [Quantity] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Discount' THEN [Discount] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Discount desc' THEN [Discount] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice' THEN [ExtendedPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice desc' THEN [ExtendedPrice] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Freight' THEN [Freight] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Freight desc' THEN [Freight] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[ShipName], ") 
            sb.Append("[ShipAddress], ") 
            sb.Append("[ShipCity], ") 
            sb.Append("[ShipRegion], ") 
            sb.Append("[ShipPostalCode], ") 
            sb.Append("[ShipCountry], ") 
            sb.Append("[CustomerID], ") 
            sb.Append("[CustomerName], ") 
            sb.Append("[Address], ") 
            sb.Append("[City], ") 
            sb.Append("[Region] AS [Region1], ") 
            sb.Append("[PostalCode], ") 
            sb.Append("[Country], ") 
            sb.Append("[Salesperson], ") 
            sb.Append("[OrderID], ") 
            sb.Append("[OrderDate], ") 
            sb.Append("[RequiredDate], ") 
            sb.Append("[ShippedDate], ") 
            sb.Append("[ShipperName], ") 
            sb.Append("[ProductID], ") 
            sb.Append("[ProductName], ") 
            sb.Append("[UnitPrice], ") 
            sb.Append("[Quantity], ") 
            sb.Append("[Discount], ") 
            sb.Append("[ExtendedPrice], ") 
            sb.Append("[Freight] ") 
            sb.Append("FROM [dbo].[Invoices] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
