Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class OrderDetailsExtendedSql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Order Details Extended]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[OrderID], ")
            sb.Append("[ProductID], ")
            sb.Append("[ProductName], ")
            sb.Append("[UnitPrice], ")
            sb.Append("[Quantity], ")
            sb.Append("[Discount], ")
            sb.Append("[ExtendedPrice] ")
            sb.Append("FROM [dbo].[Order Details Extended] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID' THEN [OrderID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'OrderID desc' THEN [OrderID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductID' THEN [ProductID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductID desc' THEN [ProductID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice' THEN [UnitPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'UnitPrice desc' THEN [UnitPrice] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Quantity' THEN [Quantity] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Quantity desc' THEN [Quantity] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'Discount' THEN [Discount] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'Discount desc' THEN [Discount] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice' THEN [ExtendedPrice] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ExtendedPrice desc' THEN [ExtendedPrice] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[OrderID], ") 
            sb.Append("[ProductID], ") 
            sb.Append("[ProductName], ") 
            sb.Append("[UnitPrice], ") 
            sb.Append("[Quantity], ") 
            sb.Append("[Discount], ") 
            sb.Append("[ExtendedPrice] ") 
            sb.Append("FROM [dbo].[Order Details Extended] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
