Imports System 
Imports System.Text 

Namespace DataLayer.Base
    Public NotInheritable Class SalesByCategorySql
        Private Sub New() 
        End Sub 

        Public Shared Function GetRecordCount() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Sales by Category]")

            Return sb.ToString() 
        End Function 

        Public Shared Function SelectSkipAndTake() As String 
            Dim selectStatement As String = GetSelectStatement() 
            Dim sb As New StringBuilder() 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start - 1; ")

            sb.Append("SELECT ")
            sb.Append("[CategoryID], ")
            sb.Append("[CategoryName], ")
            sb.Append("[ProductName], ")
            sb.Append("[ProductSales] ")
            sb.Append("FROM [dbo].[Sales by Category] ")
            sb.Append("ORDER BY ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductName' THEN [ProductName] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductName desc' THEN [ProductName] END DESC, ")

	        sb.Append("CASE WHEN @sortByExpression = 'ProductSales' THEN [ProductSales] END, ")
	        sb.Append("CASE WHEN @sortByExpression = 'ProductSales desc' THEN [ProductSales] END DESC ")

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ")
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ")

            Return sb.ToString() 
        End Function 

        Public Shared Function GetSelectStatement() As String 
            Dim sb As New StringBuilder() 

            sb.Append("SELECT ") 
            sb.Append("[CategoryID], ") 
            sb.Append("[CategoryName], ") 
            sb.Append("[ProductName], ") 
            sb.Append("[ProductSales] ") 
            sb.Append("FROM [dbo].[Sales by Category] ") 

            Return sb.ToString() 
        End Function 
    End Class 
End Namespace 
